#include <iostream.h>

class Tracer
{
public:
  Tracer(const char* tracestring);
  ~Tracer(); // destructor
private:
  const char* string;
};

Tracer::Tracer(const char* tracestring)
  : string(tracestring)
{
  cout << "+ " << string << endl;
}

Tracer::~Tracer()
{
  cout << "- " << string << endl;
}

class A : public Tracer
{
public:
  A(const char* name1, const char* name2)
   : Tracer(name1),
     trc(name2) { cout << "A" << endl;}
  virtual ~A() { cout << "~A" << endl;}
private:
  Tracer trc;
};

class B : public A
{
public:
  B(const char* n1, const char* n2, const char* n3)
    : A(n1, n2), trc(n3) { cout << "B" << endl;};
  virtual ~B() { cout << "~B" << endl;}
private:
  Tracer trc;
};

int main(void)
{
  cout << "creating an A" << endl;
  A a("A-ancestor", "A-component");
  {
    cout << "creating a B" << endl;
    B b("B-A-ancestor", "B-A-component", "B-component");
    cout << "destroying a B" << endl;
  }
  cout << "destroying an A" << endl;
  return 0;
}
